#include "system.h"
#include "filosofo.h"

extern VoidF Mozo;
int MinTiempoMozo,MaxTiempoMozo;

/******************************************************************/
void SetearAlarmaAperiodica(void)
{
ProcesoType*Proceso = DatosGlobales->Proceso+PMOZO;
long Tiempo=random();
	Tiempo=Tiempo % (MaxTiempoMozo-MinTiempoMozo);
	Tiempo+=MinTiempoMozo;
	Tiempo += Proceso->Meta;
	//long LaunchTime = Tiempo + GetHoraActual () - HoraInicioDelPrograma; 
	LogPrint("(Aperiodicas) Tiempo para lanzar al mozo: %i",Tiempo);
	alarm(Tiempo);
}

/******************************************************************/
void LanzarMozo(void)
{
ProcesoType*Proceso=DatosGlobales->Proceso + PMOZO;

	if (Proceso->Estado!=ESTADO_NO_CREADO)
	return;

	Proceso->ComienzoDelPeriodo=GetHoraActual();
//    Proceso->Periodo=Proceso->Meta=100;
//    Proceso->TiempoPensar=10;
//    Proceso->TiempoComer=10;

    Fork(Mozo,0);
    SendSignal(DatosGlobales->pid_Planificador,SIG_REPLANIFICAR);
    SendSignal(DatosGlobales->pid_Supervisor,SIG_NUEVOPROCESO);
    
}

/******************************************************************/
void AperiodicasSignal(int sig)
{
    signal(SIGALRM,(SIG_PF)AperiodicasSignal);
    signal(SIGUSR1,(SIG_PF)AperiodicasSignal);

    //LogPrint("(Aperiodicas) Alarma: %i",sig);
}

/******************************************************************/
void Aperiodicas(int nada)
{
    (void)nada;
    LogPrint("(Aperiodicas) Comienzo Inicializacion");

    AttachSharedMem();
    DatosGlobales->pid_Aperiodicas=getpid();
    signal(SIGALRM,(SIG_PF)AperiodicasSignal);
    signal(SIGUSR1,(SIG_PF)AperiodicasSignal);

    LogPrint("(Aperiodicas) Fin Inicializacion");

    SetearAlarmaAperiodica();
    pause();

    while(!DatosGlobales->TerminarFlag)
    {
		WaitSemaf();

		LanzarMozo();
		SetearAlarmaAperiodica();

		SignalSemaf();

		pause();
    }
    
	DettachSharedMem();
    LogPrint("(Aperiodicas) Termina");
}


