#ifndef Filosofos_Header_Included
#define Filosofos_Header_Included

/****************************************************/

#include "signal.h"

#ifndef __BORLANDC__

#include "sysent.h"

#include "sys/ipc.h"
#include "sys/shm.h"
//#include "sys/msg.h"

#include "sys/times.h"
#include "sys/time.h"

#endif

/******************************************************************/
#ifdef __BORLANDC__
    void alarm(int);
    void kill(int,int);
    void pause();
    void sleep(int);
    void nice(int);
    int getpid();
    int fork();
    typedef void (*SIG_PF)(int);
    #define SIGUSR1 1
    #define SIGUSR2 1
    #define SIGALRM 1
    #define SIGKILL 1
    #define SIGSTOP 1
    #define SIGCONT 1

#endif

/****************************************************/

#define CANT_FIL  5
#define SHARED_KEY 12345
#define PMOZO CANT_FIL


/******************************************************************/
//Definiciones necesarias para memoria compartida


    void CreateSharedMem(void);
    void AttachSharedMem(void);
    void DettachSharedMem(void);
    void DestroySharedMem(void);
	void WaitSemaf(void);
	void SignalSemaf(void);

    typedef enum
    {
        ESTADO_NO_CREADO,
        ESTADO_ESPERANDO_PENSAR,
        ESTADO_PENSANDO,
        ESTADO_ESPERANDO_PALITOS,
        ESTADO_COMIENDO,
        ESTADO_OCIOSO
    }EstadoEnum;

	typedef struct
    {
        int pid;
        int Periodo,Meta,TiempoPensar,TiempoComer;
        long int TiempoPensado; //En segundos
        long int ComienzoDelPeriodo; //En segundos
        EstadoEnum Estado;

        //Esto es para el mozo. Cuando se crea se pone en FALSE todo.
        //Cada vez que limpia uno se cambia el valor a TRUE.
		int Limpiando;
	}ProcesoType;

    //Los palitos y los filosofos se numeran de 0 a CANT_FIL-1

    typedef  struct {
        int Check;
	int TerminarFlag;
        ProcesoType Proceso[CANT_FIL+1]; // 0 a CANT_FIL-1=Filosofos; CANT_FIL=Mozo;
        int pid_Planificador;
        int pid_Supervisor;
        int pid_Aperiodicas;
        int pid_AdministradorPalitos;

        //Estadisticas
        int CantFilosofosMuertos;
        int CantMozosMuertos;

    }DatosGlobalesType;


    extern int IdSharedMem;
    extern DatosGlobalesType* DatosGlobales;

/****************************************************/

    typedef enum
    {
        //Planificador
        SIG_FINPENSAR =SIGUSR1,
        SIG_REPLANIFICAR=SIGUSR2,

        //Admin. Palitos
        SIG_DARPALITOS=SIGUSR1,

		//Filosofo
        SIG_COMIENZAPENSAR=SIGUSR1,
        SIG_RECIVEPALITOS=SIGUSR2,

        //Supervisor
        SIG_NUEVOPROCESO=SIGUSR1,

        //General
        SIG_TERMINAR=SIGUSR1,
        SIG_MATAR=SIGKILL,
        SIG_PARAR=SIGSTOP,
        SIG_CONTINUAR=SIGCONT
    }SIG_ENUM;
    void SendSignal(int pid,SIG_ENUM signal);

    typedef void (VoidF)(int);
    int Fork(VoidF f,int dato=0);

    void LogPrint(const char *fmt, ... );
    long GetHoraActual();
    long GetCPUTime();

/****************************************************/

    typedef enum
    {
		TAZA_MONOTONICA=0,
		META_ANTERIOR_PRIMERO=1,
		MENOR_FLEXIBILIDAD_PRIMERO=2
	}ALGOR_DE_PLANIF_ENUM;
	extern ALGOR_DE_PLANIF_ENUM ALGORITMO_DE_PLANIFICACION;

	extern int MinTiempoMozo,MaxTiempoMozo;

/****************************************************/

#endif
/****************************************************/
/****************************************************/
/****************************************************/


