/*****************************************************************/

#include "system.h"

/*****************************************************************/

    const char NO_MEMORY[]="No alcanza la memoria";
    int GraficosOn=FALSE;

/****************************************************/
int ConvertirAVector(char*Datos,int*Lista,int& CantEnLista,int MaxElemEnLista)
{
    Assert(MaxElemEnLista>0);
    Assert(Lista!=NULL);
    Assert(Datos!=NULL);


    CantEnLista=0;
    while( Datos && Datos[0] && (CantEnLista<MaxElemEnLista) )
    {
        Lista[CantEnLista++]=atoi(Datos);

        Datos=strchr(Datos,',');
        if (Datos!=NULL)
            Datos++;
    }
    return(FALSE);
}

/*****************************************************************/
int NumeroAlAzar(int maximo)
{
static long idum=123456789L;
long k;

    k    = idum/127773L;
    idum = 16807L * (idum - k * 127773L) - 2836L * k;
    if (idum < 0)
        idum+=2147483647L;

    return (int) (idum % maximo);
}

/*****************************************************************/
char *StrNCpy(char *string1,const char *string2, size_t count)
{
    strncpy(string1,string2,count);
    if (count>0)
        string1[count-1]=0;
    return(string1);
}

/*****************************************************************/
int LeerRenglonDeArchivo(char *string, int n, FILE *fp )
{
    if (fgets(string,n,fp)==NULL)
        return(TRUE);
        
    if (string[0]==0)
        return(FALSE);
        
    if (string[strlen(string)-1]=='\n')
        string[strlen(string)-1]=0;
        
    return(FALSE);
}

/*****************************************************************/
int LeerRenglonDeArchivoSinComentario(char *string, int n, FILE *fp,int&Renglon )
//Saltea los renglones en blanco
{
char*aux;
    do{
        if (LeerRenglonDeArchivo(string,n,fp))
            return(TRUE);
        Renglon++;

        aux=string;
        do
        {
            aux=strchr(aux,'/');
            if(aux!=NULL)
            {
                aux++;
                if (*aux == '/' )
                {
                    aux--;
                    *aux=0;
                    break;
                }
            }
        }while(aux!=NULL);

        //aux=strstr(string,"//");

        RTrim(string);

    }while(string[0]==0);
    return(FALSE);
}

/*****************************************************************/
char*RTrim(char*str)
{
int pos;
    pos=strlen(str)-1;
    while (pos>=0)
    {
        if( (str[pos]!=' ') && (str[pos]!='\t') )
            break;
        
        str[pos]=0;
        pos--;
    }
    return(str);
}

/*****************************************************************/
char*LTrim(char*str)
{    
int pos=0;
    while (str[pos])
    {
        if( (str[pos]!=' ') && (str[pos]!='\t') )
            break;
        pos++;
    }
    
    if (pos>0)
        strcpy(str,str+pos);
    return(str);
}

/*****************************************************************/
char*AllTrim(char*str)
{    
    return(LTrim(RTrim(str)));
}

/*****************************************************************/
char* Ultimos(const char*p,int cant)
{
    int len=(int)strlen(p);
    if (len<=cant)
        return((char*)p);
    return((char*)p+len-cant);
}

/*****************************************************************/
long double Absoluto(long double a)
{
    if (a<0) return(-a);
    return(a);
}

/*****************************************************************/
int Signo(long double a)
{
    if (a<0) return(-1);
    if (a>0) return( 1);
    return(0);
}

/*****************************************************************/
int MismoSigno(long double a,long double b)
{
    return(Signo(a)==Signo(b));
}

/*****************************************************************/
void AgregarBarraAlFinal(char* Path)
{
    if (!Path[0])
    {
        strcpy(Path,"\\");
        return;
    }

    if( Path[strlen(Path)-1]!='\\')
        strcat(Path,"\\");
}

/*****************************************************************/
int FileExist(char*name)
{
    FILE* fp=fopen(name,"rb");
    if (fp==NULL)
        return(FALSE);
    fclose(fp);
    return(TRUE);
}

/*****************************************************************/
long FileSize(char*name)
{
    (void)name;
    return(Error(FatalError,"FileSize no implementada"));
}

/*****************************************************************/
void Terminar(int ExitCode)
{
    exit(ExitCode);
}



