/******************************************************************/

#include "system.h"
#include "filosofo.h"

/******************************************************************/

static ProcesoType*Proceso;

/******************************************************************/
void MozoSignal(int sig)
{
	signal(SIG_COMIENZAPENSAR,(SIG_PF)MozoSignal);
	signal(SIG_RECIVEPALITOS,(SIG_PF)MozoSignal);
    if (DatosGlobales->TerminarFlag)
    {
		DettachSharedMem();
		LogPrint("(Mozo) Terminado.");
		exit(0);
    }	

    if (sig==SIG_COMIENZAPENSAR)
    {
        Assert(Proceso->Estado==ESTADO_PENSANDO);
		//LogPrint("(Mozo) Signal SIG_COMIENZA_PENSAR");
    }
    else if (sig==SIG_RECIVEPALITOS)
    {
        Assert(Proceso->Estado==ESTADO_COMIENDO);
		//LogPrint("(Mozo) Signal SIG_RECIVEPALITOS");
    }
    else
        Assert(FALSE);
}

/******************************************************************/
void MozoPensar()
{
    if(Proceso->Estado!=ESTADO_PENSANDO)	
        pause();

    long int CPuUsadaAlComienzoPensar=GetCPUTime();
	LogPrint("(Mozo) Comienza Pensar");

    Proceso->TiempoPensado=0;

    int TiempoAPensar=Proceso->TiempoPensar;
    Assert(Proceso->Estado==ESTADO_PENSANDO);

    while(Proceso->TiempoPensado < TiempoAPensar)
    {
        long int CPuUsada=GetCPUTime();
        Proceso->TiempoPensado=CPuUsada-CPuUsadaAlComienzoPensar;
    };

	LogPrint("(Mozo) Fin Pensar");

    //Indico que necesito los palitos
    Proceso->Estado=ESTADO_ESPERANDO_PALITOS;
    SendSignal(DatosGlobales->pid_AdministradorPalitos,SIG_DARPALITOS);
    SendSignal(DatosGlobales->pid_Planificador,SIG_FINPENSAR);
}

/******************************************************************/
void MozoComer()
{
    //Espero que me avisen que tengo los palitos
    if(Proceso->Estado!=ESTADO_COMIENDO)	
        pause();
	LogPrint("(Mozo) Comienzo Comer");

    Assert(Proceso->Estado==ESTADO_COMIENDO);
    sleep(Proceso->TiempoComer);

	LogPrint("(Mozo) Fin Comer");
	if (Proceso->Limpiando==CANT_FIL-1)
	{
		Proceso->Limpiando=-1;
        Proceso->Estado=ESTADO_OCIOSO;
		LogPrint ("(Mozo) Me salve!!!");
	}
	else
		Proceso->Estado=ESTADO_ESPERANDO_PENSAR;

	SendSignal(DatosGlobales->pid_Planificador,SIG_FINPENSAR);
	SendSignal(DatosGlobales->pid_AdministradorPalitos,SIG_DARPALITOS);
}

/******************************************************************/
void Mozo(int nada)
{
	(void)nada;
	LogPrint("(Mozo) Comienzo Inicializacion");

    AttachSharedMem();

	signal(SIG_COMIENZAPENSAR,(SIG_PF)MozoSignal);
	signal(SIG_RECIVEPALITOS,(SIG_PF)MozoSignal);
    Assert(DatosGlobales->Check==12345);
	Proceso=DatosGlobales->Proceso + PMOZO;

    Proceso->pid=getpid();
    Proceso->TiempoPensado=0;
    Proceso->ComienzoDelPeriodo=GetHoraActual();
    Proceso->Limpiando = -1;

	LogPrint("(Mozo) Fin Inicializacion");
    Proceso->Estado=ESTADO_ESPERANDO_PENSAR;

    nice(1);

    while(!DatosGlobales->TerminarFlag)
    {
		for(int i=0;i<CANT_FIL;i++)
		{
			MozoPensar();
			MozoComer();
		}
    }

    DettachSharedMem();
	LogPrint("(Mozo) Termina");
}

/******************************************************************/
/******************************************************************/

